function [sig1, sig2] = RedistributePointsSig(edge1, sig1, edge2, sig2)

%RIGID TRANSFORMATION OF EDGE
rigidTransformation1 = estimateRigidTransform(edge1',fliplr(edge2'));
rotationMatrix1      = rigidTransformation1(1:3,1:3);
translantion1        = rigidTransformation1(1:3,4);
for j=1:length(edge2(:,1))
    edge2(j,:)=(rotationMatrix1*(edge2(j,:))'+translantion1)';
end

%DETERMINE NEAREST POINT
for i=1:length(edge2(:,1))
    initialDistance(i) = sqrt((edge1(1,1)-edge2(i,1))^2+(edge1(1,2)-edge2(i,2))^2+(edge1(1,3)-edge2(i,3))^2);
    finalDistance(i)   = sqrt((edge1(end,1)-edge2(i,1))^2+(edge1(end,2)-edge2(i,2))^2+(edge1(end,3)-edge2(i,3))^2);
end

[dist, index(1)] = min(initialDistance);
[dist, index(2)] = min(finalDistance);
index            = sort(index);

% figure(1); hold on
% plot3(sig2(:,1),sig2(:,2),sig2(:,3),'.b');
% plot3(sig2(:,1),sig2(:,2),sig2(:,3));
% plot3(sig1(:,1),sig1(:,2),sig1(:,3),'k');


sig2      = SmootherSegments(sig2(index(1):index(2),:),0.00000001);

% plot3(sig2(:,1),sig2(:,2),sig2(:,3),'.r');
% plot3(sig2(:,1),sig2(:,2),sig2(:,3),'r');


end