function output=PutTogether(edge1,edge2,piece1,piece2)

%TEST IF LENGTH OF THE EDGES IS SIGNIFICANTLY DIFFERENT
distances = zeros(2,1);
for i=2:length(edge1(:,1))
    distances(1) = sqrt((edge1(i,1)-edge1(i-1,1))^2+(edge1(i,2)-edge1(i-1,2))^2+(edge1(i,3)-edge1(i-1,3))^2)+distances(1);
    distances(2) = sqrt((edge2(i,1)-edge2(i-1,1))^2+(edge2(i,2)-edge2(i-1,2))^2+(edge2(i,3)-edge2(i-1,3))^2)+distances(2);
end
distances = sort(distances);

%TRANSFORMATION MATRICES
rigidTransformation1 = estimateRigidTransform(edge1',fliplr(edge2'));
rotationMatrix1      = rigidTransformation1(1:3,1:3);
translantion1        = rigidTransformation1(1:3,4);

rigidTransformation2 = estimateRigidTransform(edge1',edge2');
rotationMatrix2      = rigidTransformation2(1:3,1:3);
translation2         = rigidTransformation2(1:3,4);

%ROTATING PIECES
shiftedPiece2a = zeros(length(piece2),3);
shiftedPiece2b = zeros(length(piece2),3);
for a=1:length(piece2)
    shiftedPiece2a(a,:)=(rotationMatrix1*(piece2(a,:))'+translantion1)';
end
for a=1:length(piece2)
    shiftedPiece2b(a,:)=(rotationMatrix2*(piece2(a,:))'+translation2)';
end

%DETERMINING BETTER ROTATION MATRIX
shiftedEdge2a = zeros(length(edge2),3);
shiftedEdge2b = zeros(length(edge2),3);
for j=1:length(edge2(:,1))
    shiftedEdge2a(j,:)=(rotationMatrix1*(edge2(j,:))'+translantion1)';
end
for j=1:length(edge2(:,1))
    shiftedEdge2b(j,:)=(rotationMatrix2*(edge2(j,:))'+translation2)';
end

edgeHaus(1) = HausdorffDist(edge1,shiftedEdge2a);
edgeHaus(2) = HausdorffDist(edge1,shiftedEdge2b);

%OUTPUT
if HausdorffDist(edge1,shiftedEdge2a)>0.07 || distances(1)/distances(2)<0.8 || min(edgeHaus)/max(edgeHaus)>=0.93 || edgeHaus(2)/edgeHaus(1)<0.93
    
        fprintf('FAIL: THE HAUS IS %f, RATIO IS %f, AND OTHER FIT IS %f\n',edgeHaus(1),distances(1)/distances(2),edgeHaus(2));
        disp(edgeHaus(2)/edgeHaus(1));
        figure(5); hold on
        plot3(piece1(:,1),piece1(:,2),piece1(:,3),'k','LineWidth',2);
        plot3(shiftedPiece2a(:,1),shiftedPiece2a(:,2),shiftedPiece2a(:,3),'LineWidth',2);
        plot3(edge1(:,1),edge1(:,2),edge1(:,3),'.g','LineWidth',2);
        plot3(shiftedEdge2a(:,1),shiftedEdge2a(:,2),shiftedEdge2a(:,3),'.r','LineWidth',2);
    
    output ='w';
else
        fprintf('PASS: THE HAUS IS %f, RATIO IS %f, AND OTHER FIT IS %f\n',edgeHaus(1),distances(1)/distances(2),edgeHaus(2));
        figure(5); hold on
        plot3(piece1(:,1),piece1(:,2),piece1(:,3),'k','LineWidth',2);
        plot3(shiftedPiece2a(:,1),shiftedPiece2a(:,2),shiftedPiece2a(:,3),'LineWidth',2);
        plot3(edge1(:,1),edge1(:,2),edge1(:,3),'.g','LineWidth',2);
        plot3(shiftedEdge2a(:,1),shiftedEdge2a(:,2),shiftedEdge2a(:,3),'.r','LineWidth',2);
    output = rigidTransformation1;
end
% output = rigidTransformation1;
% %PLOTTING PIECES
% figure(5); hold on
% plot3(piece1(:,1),piece1(:,2),piece1(:,3),'k','LineWidth',2);
% plot3(shiftedPiece2a(:,1),shiftedPiece2a(:,2),shiftedPiece2a(:,3),'LineWidth',2);
% plot3(edge1(:,1),edge1(:,2),edge1(:,3),'.g','LineWidth',2);
% plot3(shiftedEdge2a(:,1),shiftedEdge2a(:,2),shiftedEdge2a(:,3),'.r','LineWidth',2);

% figure(2); hold on
% plot3(piece1(:,1),piece1(:,2),piece1(:,3),'k','LineWidth',2);
% plot3(p2b(:,1),p2b(:,2),p2b(:,3),'LineWidth',2);
% plot3(c1(:,1),c1(:,2),c1(:,3),'.r','LineWidth',2);
end

%%
