function [ smooth_points ] = SmootherSegments( filename, sparam )
%Takes as input a file containing a list of points and outputs an ordered
%   list of smoothened points. Outputted list always contains 1k points.
%   The smoothing parameter needs to be very low. Usually around .001.

if nargin<2
   sparam = .01; 
    
end
points = filename;
t = 0:(size(points,1)-1);
w = ones(size(t));
sp = spaps(t,points',sparam,w,3);

randomMatrix = 0:0.01:1;


r =  randomMatrix * (size(points,1)-1); %rand(1000,1)

r = sort(r);

x = fnval(sp,r)';

% rotate3d on;
% 
% plot3(x(:,1),x(:,2),x(:,3),'r--');
% hold on;
% plot3(points(:,1),points(:,2),points(:,3),'b-');

smooth_points = x;

end

